import 'package:templatr/html.dart';
import 'package:templatr/widget.dart';

String form({
  String id,
  Map<String, String> style,
  List<String> classes,
  List<String> content = const [],
  bool validate = true,
}) =>
    ElementWidget(
      'sl-form',
      id: id,
      style: style,
      classes: classes,
      attributes: {'novalidate': !validate},
      newlineAfterStart: true,
    )(content);

String input({
  String id,
  Map<String, String> style,
  List<String> classes,
  String name,
  InputType type,
  String label,
  String value,
  bool disabled,
  bool readonly,
}) =>
    ElementWidget(
      'sl-input',
      id: id,
      style: style,
      classes: classes,
      attributes: {
        'name': name,
        'type': type?.name,
        'label': label,
        'value': value,
        'disabled': disabled,
        'readonly': readonly,
      },
    )();

String select({
  String id,
  Map<String, String> style,
  List<String> classes,
  String name,
  String label,
  List<String> items = const [],
}) =>
    ElementWidget(
      'sl-select',
      id: id,
      style: style,
      classes: classes,
      attributes: {
        'name': name,
        'label': label,
      },
      newlineAfterStart: true,
    )(items);

String checkbox(
  String label, {
  String id,
  Map<String, String> style,
  List<String> classes,
  String name,
  bool checked = false,
  String value,
}) =>
    ElementWidget(
      'sl-checkbox',
      id: id,
      style: style,
      classes: classes,
      attributes: {
        'name': name,
        'checked': checked,
        'value': value,
      },
    )(label);
